Hex Artifact Content

Artifact f1041debf171a035f76b29567172b46bd4e488a0:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50   verifyRequiredP
0570: 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63  ackages() {..loc
0580: 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e  al pkg pkgdomain
0590: 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63   pkgversion..loc
05a0: 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e  al pkgdir pkgcon
05b0: 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a  figdir pkgfound.
05c0: 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b  ..for pkg in "${
05d0: 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f  require[@]}"; do
05e0: 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a  ...pkgdomain=''.
05f0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a  ..pkgversion=''.
0600: 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22  ...case "${pkg}"
0610: 20 69 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09 09   in....*/*@*)...
0620: 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65  ..pkgdomain="$(e
0630: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0640: 75 74 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22  ut -f 2 -d '@')"
0650: 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d  .....pkgversion=
0660: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
0670: 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27   | cut -f 2 -d '
0680: 2f 27 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64  /' | cut -f 1 -d
0690: 20 27 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22   '@')".....pkg="
06a0: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
06b0: 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f  | cut -f 1 -d '/
06c0: 27 29 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2f  ')".....;;....*/
06d0: 2a 29 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f  *).....pkgversio
06e0: 6e 3d 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67  n="$(echo "${pkg
06f0: 7d 22 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64  }" | cut -f 2 -d
0700: 20 27 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d 22   '/')".....pkg="
0710: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0720: 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f  | cut -f 1 -d '/
0730: 27 29 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 40  ')".....;;....*@
0740: 2a 29 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69 6e  *).....pkgdomain
0750: 3d 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d  ="$(echo "${pkg}
0760: 22 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20  " | cut -f 2 -d 
0770: 27 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24  '@')".....pkg="$
0780: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0790: 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27   cut -f 1 -d '@'
07a0: 29 22 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63  )".....;;...esac
07b0: 0a 0a 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 70  ....if [ -z "${p
07c0: 6b 67 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74 68  kgdomain}" ]; th
07d0: 65 6e 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d  en....pkgdomain=
07e0: 22 24 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66 69  "${domain}"...fi
07f0: 0a 0a 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30 27  ....pkgfound='0'
0800: 0a 09 09 66 6f 72 20 70 6b 67 64 69 72 20 69 6e  ...for pkgdir in
0810: 20 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70   "/opt/appfs/${p
0820: 6b 67 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d  kgdomain}/${pkg}
0830: 2f 70 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67  /platform"/${pkg
0840: 76 65 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a  version:-*}; do.
0850: 09 09 09 70 6b 67 63 6f 6e 66 69 67 64 69 72 3d  ...pkgconfigdir=
0860: 22 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f 70  "${pkgdir}/lib/p
0870: 6b 67 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69 66  kgconfig".....if
0880: 20 5b 20 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d   [ -d "${pkgdir}
0890: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b  " ]; then.....pk
08a0: 67 66 6f 75 6e 64 3d 27 31 27 0a 09 09 09 66 69  gfound='1'....fi
08b0: 0a 0a 09 09 09 43 46 4c 41 47 53 3d 22 24 7b 43  .....CFLAGS="${C
08c0: 46 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64 69  FLAGS} -I${pkgdi
08d0: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09 43  r}/include"....C
08e0: 50 50 46 4c 41 47 53 3d 22 24 7b 43 50 50 46 4c  PPFLAGS="${CPPFL
08f0: 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64 69 72 7d  AGS} -I${pkgdir}
0900: 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09 4c 44 46  /include"....LDF
0910: 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d  LAGS="${LDFLAGS}
0920: 20 2d 4c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62   -L${pkgdir}/lib
0930: 20 2d 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 70 6b   -Wl,-rpath,${pk
0940: 67 64 69 72 7d 2f 6c 69 62 22 0a 09 09 09 50 41  gdir}/lib"....PA
0950: 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b 70 6b  TH="${PATH}:${pk
0960: 67 64 69 72 7d 2f 62 69 6e 22 0a 09 09 09 65 78  gdir}/bin"....ex
0970: 70 6f 72 74 20 43 46 4c 41 47 53 20 43 50 50 46  port CFLAGS CPPF
0980: 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41 54  LAGS LDFLAGS PAT
0990: 48 0a 0a 09 09 09 69 66 20 5b 20 2d 64 20 22 24  H.....if [ -d "$
09a0: 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22 20  {pkgconfigdir}" 
09b0: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 50 4b 47 5f  ]; then.....PKG_
09c0: 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 7b 50  CONFIG_PATH="${P
09d0: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 7d 3a  KG_CONFIG_PATH}:
09e0: 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22  ${pkgconfigdir}"
09f0: 0a 09 09 09 09 65 78 70 6f 72 74 20 50 4b 47 5f  .....export PKG_
0a00: 43 4f 4e 46 49 47 5f 50 41 54 48 0a 09 09 09 66  CONFIG_PATH....f
0a10: 69 0a 0a 09 09 64 6f 6e 65 0a 0a 09 09 69 66 20  i....done....if 
0a20: 5b 20 22 24 7b 70 6b 67 66 6f 75 6e 64 7d 22 20  [ "${pkgfound}" 
0a30: 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a 09 09  = '0' ]; then...
0a40: 09 64 69 65 20 22 50 61 63 6b 61 67 65 20 24 7b  .die "Package ${
0a50: 70 6b 67 7d 2f 24 7b 70 6b 67 76 65 72 73 69 6f  pkg}/${pkgversio
0a60: 6e 3a 2d 2a 7d 40 24 7b 70 6b 67 64 6f 6d 61 69  n:-*}@${pkgdomai
0a70: 6e 7d 20 6e 6f 74 20 66 6f 75 6e 64 2e 22 0a 09  n} not found."..
0a80: 09 66 69 0a 09 64 6f 6e 65 0a 7d 0a 0a 66 75 6e  .fi..done.}..fun
0a90: 63 74 69 6f 6e 20 76 65 72 69 66 79 50 72 65 72  ction verifyPrer
0aa0: 65 71 75 69 73 69 74 65 73 28 29 20 7b 0a 09 3a  equisites() {..:
0ab0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74  .}..function det
0ac0: 65 72 6d 69 6e 65 4f 73 41 72 63 68 28 29 20 7b  ermineOsArch() {
0ad0: 0a 09 6f 73 3d 22 24 28 75 6e 61 6d 65 20 2d 73  ..os="$(uname -s
0ae0: 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73 65   | dd conv=lcase
0af0: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a 09   2>/dev/null)"..
0b00: 61 72 63 68 3d 22 24 28 75 6e 61 6d 65 20 2d 6d  arch="$(uname -m
0b10: 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73 65   | dd conv=lcase
0b20: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a 0a   2>/dev/null)"..
0b30: 09 63 61 73 65 20 22 24 7b 61 72 63 68 7d 22 20  .case "${arch}" 
0b40: 69 6e 0a 09 09 69 3f 38 36 29 0a 09 09 09 61 72  in...i?86)....ar
0b50: 63 68 3d 27 69 78 38 36 27 0a 09 09 09 3b 3b 0a  ch='ix86'....;;.
0b60: 09 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f  .esac.}..functio
0b70: 6e 20 64 65 74 65 72 6d 69 6e 65 50 72 65 66 69  n determinePrefi
0b80: 78 28 29 20 7b 0a 09 64 65 74 65 72 6d 69 6e 65  x() {..determine
0b90: 4f 73 41 72 63 68 0a 0a 09 70 72 65 66 69 78 73  OsArch...prefixs
0ba0: 75 66 66 69 78 3d 22 24 7b 70 6b 67 7d 2f 24 7b  uffix="${pkg}/${
0bb0: 6f 73 7d 2d 24 7b 61 72 63 68 7d 2f 24 7b 76 65  os}-${arch}/${ve
0bc0: 72 73 69 6f 6e 7d 22 0a 09 70 72 65 66 69 78 3d  rsion}"..prefix=
0bd0: 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 64 6f  "/opt/appfs/${do
0be0: 6d 61 69 6e 7d 2f 24 7b 70 72 65 66 69 78 73 75  main}/${prefixsu
0bf0: 66 66 69 78 7d 22 0a 09 64 65 73 74 64 69 72 3d  ffix}"..destdir=
0c00: 22 24 28 70 77 64 29 2f 49 4e 53 54 22 0a 0a 09  "$(pwd)/INST"...
0c10: 6d 6b 64 69 72 20 22 24 7b 64 65 73 74 64 69 72  mkdir "${destdir
0c20: 7d 22 20 7c 7c 20 64 69 65 0a 7d 0a 0a 66 75 6e  }" || die.}..fun
0c30: 63 74 69 6f 6e 20 70 72 65 63 6f 6e 66 69 67 75  ction preconfigu
0c40: 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  re() {..:.}..fun
0c50: 63 74 69 6f 6e 20 70 6f 73 74 63 6f 6e 66 69 67  ction postconfig
0c60: 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ure() {..:.}..fu
0c70: 6e 63 74 69 6f 6e 20 63 6f 6e 66 69 67 75 72 65  nction configure
0c80: 28 29 20 7b 0a 09 67 6c 69 62 63 76 65 72 73 3d  () {..glibcvers=
0c90: 32 2e 32 30 0a 09 67 6c 69 62 63 64 69 72 3d 22  2.20..glibcdir="
0ca0: 2f 6f 70 74 2f 61 70 70 66 73 2f 63 6f 72 65 2e  /opt/appfs/core.
0cb0: 61 70 70 66 73 2e 72 6b 65 65 6e 65 2e 6f 72 67  appfs.rkeene.org
0cc0: 2f 67 6c 69 62 63 2f 70 6c 61 74 66 6f 72 6d 2f  /glibc/platform/
0cd0: 24 7b 67 6c 69 62 63 76 65 72 73 7d 22 0a 09 64  ${glibcvers}"..d
0ce0: 79 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73 20 22  ynlinker="$(ls "
0cf0: 24 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c 69 62  ${glibcdir}"/lib
0d00: 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e 2a 20  /ld-linux*.so.* 
0d10: 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a 09  | tail -n 1)"...
0d20: 69 66 20 5b 20 21 20 2d 64 20 22 24 7b 67 6c 69  if [ ! -d "${gli
0d30: 62 63 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a  bcdir}" ]; then.
0d40: 09 09 64 69 65 20 27 67 6c 69 62 63 20 64 69 72  ..die 'glibc dir
0d50: 65 63 74 6f 72 79 20 69 73 20 6e 6f 74 20 61 76  ectory is not av
0d60: 61 69 6c 61 62 6c 65 20 28 61 70 70 66 73 20 72  ailable (appfs r
0d70: 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e 67 3f 29  unning/working?)
0d80: 27 0a 09 66 69 0a 0a 09 43 46 4c 41 47 53 3d 22  '..fi...CFLAGS="
0d90: 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 67 6c  ${CFLAGS} -I${gl
0da0: 69 62 63 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  ibcdir}/include"
0db0: 0a 09 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50  ..CPPFLAGS="${CP
0dc0: 50 46 4c 41 47 53 7d 20 2d 49 24 7b 67 6c 69 62  PFLAGS} -I${glib
0dd0: 63 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09  cdir}/include"..
0de0: 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41  LDFLAGS="${LDFLA
0df0: 47 53 7d 20 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c  GS} -Wl,--rpath,
0e00: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20  ${glibcdir}/lib 
0e10: 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69  -Wl,--dynamic-li
0e20: 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72  nker,${dynlinker
0e30: 7d 22 0a 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c  }"..PKG_CONFIG_L
0e40: 49 42 44 49 52 3d 22 24 7b 67 6c 69 62 63 64 69  IBDIR="${glibcdi
0e50: 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66 69 67  r}/lib/pkgconfig
0e60: 22 0a 09 65 78 70 6f 72 74 20 43 46 4c 41 47 53  "..export CFLAGS
0e70: 20 43 50 50 46 4c 41 47 53 20 4c 44 46 4c 41 47   CPPFLAGS LDFLAG
0e80: 53 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42  S PKG_CONFIG_LIB
0e90: 44 49 52 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75 72  DIR..../configur
0ea0: 65 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70 72  e --prefix="${pr
0eb0: 65 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e 66  efix}" --sysconf
0ec0: 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61 6c  dir=/etc --local
0ed0: 73 74 61 74 65 64 69 72 3d 2f 76 61 72 20 22 24  statedir=/var "$
0ee0: 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  {configure_extra
0ef0: 5b 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f  [@]}".}..functio
0f00: 6e 20 70 72 65 62 75 69 6c 64 28 29 20 7b 0a 09  n prebuild() {..
0f10: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
0f20: 73 74 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d  stbuild() {..:.}
0f30: 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64  ..function build
0f40: 28 29 20 7b 0a 09 67 72 65 70 20 22 44 45 53 54  () {..grep "DEST
0f50: 44 49 52 22 20 4d 61 6b 65 66 69 6c 65 20 3e 2f  DIR" Makefile >/
0f60: 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 64 69 65 20  dev/null || die 
0f70: 22 44 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20  "Don't know how 
0f80: 74 6f 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f  to build this so
0f90: 66 74 77 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d  ftware"...make.}
0fa0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e  ..function prein
0fb0: 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a  stall() {..:.}..
0fc0: 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73  function postins
0fd0: 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  tall() {..:.}..f
0fe0: 75 6e 63 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28  unction install(
0ff0: 29 20 7b 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c  ) {..make instal
1000: 6c 20 44 45 53 54 44 49 52 3d 22 24 7b 64 65 73  l DESTDIR="${des
1010: 74 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69  tdir}".}..functi
1020: 6f 6e 20 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09  on cleanup() {..
1030: 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  cd "${workdir}" 
1040: 7c 7c 20 65 78 69 74 20 31 0a 09 63 64 20 2e 2e  || exit 1..cd ..
1050: 20 7c 7c 20 65 78 69 74 20 31 0a 09 72 6d 20 2d   || exit 1..rm -
1060: 72 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a  rf "${workdir}".
1070: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 69 65 28  }..function die(
1080: 29 20 7b 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61  ) {..local messa
1090: 67 65 0a 0a 09 6d 65 73 73 61 67 65 3d 22 24 31  ge...message="$1
10a0: 22 0a 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d  "...if [ -n "${m
10b0: 65 73 73 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e  essage}" ]; then
10c0: 0a 09 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20  ...echo "error: 
10d0: 24 7b 6d 65 73 73 61 67 65 7d 22 20 3e 26 32 0a  ${message}" >&2.
10e0: 09 66 69 0a 0a 09 63 6c 65 61 6e 75 70 0a 0a 09  .fi...cleanup...
10f0: 65 78 69 74 20 31 0a 7d 0a 0a 73 63 72 69 70 74  exit 1.}..script
1100: 64 69 72 3d 22 24 28 63 64 20 22 24 28 64 69 72  dir="$(cd "$(dir
1110: 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20 22 24  name "$(which "$
1120: 30 22 29 22 29 22 20 26 26 20 70 77 64 29 22 0a  0")")" && pwd)".
1130: 69 66 20 5b 20 2d 7a 20 22 24 7b 73 63 72 69 70  if [ -z "${scrip
1140: 74 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  tdir}" ]; then..
1150: 65 63 68 6f 20 22 55 6e 61 62 6c 65 20 74 6f 20  echo "Unable to 
1160: 6c 6f 63 61 74 65 20 73 63 72 69 70 74 20 64 69  locate script di
1170: 72 65 63 74 6f 72 79 22 20 3e 26 32 0a 0a 09 65  rectory" >&2...e
1180: 78 69 74 20 31 0a 66 69 0a 0a 63 64 20 22 24 7b  xit 1.fi..cd "${
1190: 73 63 72 69 70 74 64 69 72 7d 22 20 7c 7c 20 65  scriptdir}" || e
11a0: 78 69 74 20 31 0a 0a 69 66 20 5b 20 2d 66 20 27  xit 1..if [ -f '
11b0: 62 75 69 6c 64 2e 63 6f 6e 66 27 20 5d 3b 20 74  build.conf' ]; t
11c0: 68 65 6e 0a 09 2e 20 27 62 75 69 6c 64 2e 63 6f  hen... 'build.co
11d0: 6e 66 27 0a 66 69 0a 0a 69 66 20 5b 20 2d 64 20  nf'.fi..if [ -d 
11e0: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b  "pkgs/${pkg}" ];
11f0: 20 74 68 65 6e 0a 09 70 6b 67 64 69 72 3d 22 70   then..pkgdir="p
1200: 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67  kgs/${pkg}"..pkg
1210: 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69 72 7d 2f  file="${pkgdir}/
1220: 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70 6b 67 66  info".else..pkgf
1230: 69 6c 65 3d 22 70 6b 67 73 2f 24 7b 70 6b 67 7d  ile="pkgs/${pkg}
1240: 22 0a 09 70 6b 67 64 69 72 3d 22 24 7b 70 6b 67  "..pkgdir="${pkg
1250: 66 69 6c 65 7d 22 0a 66 69 0a 0a 69 66 20 5b 20  file}".fi..if [ 
1260: 21 20 2d 65 20 22 24 7b 70 6b 67 66 69 6c 65 7d  ! -e "${pkgfile}
1270: 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20  " ]; then..echo 
1280: 22 49 6e 76 61 6c 69 64 20 70 61 63 6b 61 67 65  "Invalid package
1290: 2e 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a  ." >&2...exit 1.
12a0: 66 69 0a 0a 70 6b 67 64 61 74 65 3d 22 24 28 66  fi..pkgdate="$(f
12b0: 6f 72 20 61 72 74 69 66 61 63 74 20 69 6e 20 24  or artifact in $
12c0: 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d  (find "${pkgdir}
12d0: 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74  " -type f -print
12e0: 30 20 7c 20 78 61 72 67 73 20 2d 6e 20 31 20 2d  0 | xargs -n 1 -
12f0: 30 20 66 6f 73 73 69 6c 20 66 69 6e 66 6f 20 2d  0 fossil finfo -
1300: 2d 6c 69 6d 69 74 20 31 20 2d 2d 77 69 64 74 68  -limit 1 --width
1310: 20 30 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c   0 2>/dev/null |
1320: 20 67 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d   grep '^[0-9][0-
1330: 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d  9][0-9][0-9]-[0-
1340: 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d  9][0-9]-[0-9][0-
1350: 39 5d 20 27 20 7c 20 73 65 64 20 27 73 40 5e 5b  9] ' | sed 's@^[
1360: 5e 20 5d 2a 20 5c 5b 40 40 3b 73 40 5c 5d 2e 2a  ^ ]* \[@@;s@\].*
1370: 40 40 27 20 7c 20 73 6f 72 74 20 2d 75 29 3b 20  @@' | sort -u); 
1380: 64 6f 20 66 6f 73 73 69 6c 20 69 6e 66 6f 20 22  do fossil info "
1390: 24 7b 61 72 74 69 66 61 63 74 7d 22 20 7c 20 61  ${artifact}" | a
13a0: 77 6b 20 27 2f 5e 75 75 69 64 3a 2f 7b 20 70 72  wk '/^uuid:/{ pr
13b0: 69 6e 74 20 24 33 20 24 34 20 7d 27 20 7c 20 73  int $3 $4 }' | s
13c0: 65 64 20 27 73 40 5b 2d 3a 5d 40 40 67 3b 73 40  ed 's@[-:]@@g;s@
13d0: 2e 2e 24 40 5c 2e 26 40 27 3b 20 64 6f 6e 65 20  ..$@\.&@'; done 
13e0: 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c  | sort -n | tail
13f0: 20 2d 6e 20 31 29 22 0a 69 66 20 5b 20 2d 7a 20   -n 1)".if [ -z 
1400: 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 5d 3b 20  "${pkgdate}" ]; 
1410: 74 68 65 6e 0a 09 70 6b 67 64 61 74 65 3d 22 24  then..pkgdate="$
1420: 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d  (find "${pkgdir}
1430: 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74  " -type f -print
1440: 66 20 27 25 54 59 25 54 6d 25 54 64 25 54 48 25  f '%TY%Tm%Td%TH%
1450: 54 4d 2e 25 54 53 5c 6e 27 20 32 3e 2f 64 65 76  TM.%TS\n' 2>/dev
1460: 2f 6e 75 6c 6c 20 7c 20 63 75 74 20 2d 66 20 31  /null | cut -f 1
1470: 2d 32 20 2d 64 20 27 2e 27 20 7c 20 73 6f 72 74  -2 -d '.' | sort
1480: 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29   -n | tail -n 1)
1490: 22 0a 66 69 0a 0a 2e 20 22 24 7b 70 6b 67 66 69  ".fi... "${pkgfi
14a0: 6c 65 7d 22 0a 0a 61 72 63 68 69 76 65 64 69 72  le}"..archivedir
14b0: 3d 22 24 28 70 77 64 29 2f 41 52 43 48 49 56 45  ="$(pwd)/ARCHIVE
14c0: 22 0a 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64  ".workdir="workd
14d0: 69 72 2d 24 24 24 7b 52 41 4e 44 4f 4d 7d 24 7b  ir-$$${RANDOM}${
14e0: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
14f0: 22 0a 70 6b 67 61 72 63 68 69 76 65 3d 22 24 7b  ".pkgarchive="${
1500: 61 72 63 68 69 76 65 64 69 72 7d 2f 24 7b 70 6b  archivedir}/${pk
1510: 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 6d  g}-${version}".m
1520: 6b 64 69 72 20 22 24 7b 61 72 63 68 69 76 65 64  kdir "${archived
1530: 69 72 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  ir}" >/dev/null 
1540: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d 6b 64 69  2>/dev/null.mkdi
1550: 72 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c  r "${workdir}" |
1560: 7c 20 65 78 69 74 20 31 0a 63 64 20 22 24 7b 77  | exit 1.cd "${w
1570: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
1580: 20 31 0a 77 6f 72 6b 64 69 72 3d 22 24 28 70 77   1.workdir="$(pw
1590: 64 29 22 0a 0a 23 20 44 6f 77 6e 6c 6f 61 64 0a  d)"..# Download.
15a0: 64 6f 77 6e 6c 6f 61 64 0a 0a 23 20 45 78 74 72  download..# Extr
15b0: 61 63 74 0a 65 78 74 72 61 63 74 0a 0a 23 20 49  act.extract..# I
15c0: 66 20 77 65 20 6a 75 73 74 20 68 61 76 65 20 6f  f we just have o
15d0: 6e 65 20 64 69 72 65 63 74 6f 72 79 2c 20 75 73  ne directory, us
15e0: 65 20 74 68 61 74 20 64 69 72 65 63 74 6f 72 79  e that directory
15f0: 0a 64 69 72 3d 22 24 28 65 63 68 6f 20 2a 29 22  .dir="$(echo *)"
1600: 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64 69 72 7d  .if [ -e "${dir}
1610: 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76 20 22 24  " ]; then..mv "$
1620: 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69 0a 0a 23  {dir}"/* ..fi..#
1630: 20 56 65 72 69 66 79 20 70 72 65 2d 72 65 71 75   Verify pre-requ
1640: 69 73 69 74 65 73 20 61 72 65 20 6d 65 74 0a 76  isites are met.v
1650: 65 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63  erifyRequiredPac
1660: 6b 61 67 65 73 20 7c 7c 20 64 69 65 20 27 52 65  kages || die 'Re
1670: 71 75 69 72 65 64 20 70 61 63 6b 61 67 65 73 20  quired packages 
1680: 6d 69 73 73 69 6e 67 27 0a 76 65 72 69 66 79 50  missing'.verifyP
1690: 72 65 72 65 71 75 69 73 69 74 65 73 20 7c 7c 20  rerequisites || 
16a0: 64 69 65 20 27 50 72 65 72 65 71 75 69 73 69 74  die 'Prerequisit
16b0: 69 65 73 20 66 61 69 6c 65 64 27 0a 0a 23 20 53  ies failed'..# S
16c0: 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a 73 65 74  tart logging.set
16d0: 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65   -x..# Determine
16e0: 20 70 72 6f 70 65 72 74 69 65 73 0a 64 65 74 65   properties.dete
16f0: 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a 23 20 53  rminePrefix..# S
1700: 74 61 72 74 20 74 68 65 20 62 75 69 6c 64 0a 70  tart the build.p
1710: 72 65 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64  reconfigure || d
1720: 69 65 20 27 70 72 65 63 6f 6e 66 69 67 75 72 65  ie 'preconfigure
1730: 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66 69 67 75   failed'.configu
1740: 72 65 20 7c 7c 20 64 69 65 20 27 63 6f 6e 66 69  re || die 'confi
1750: 67 75 72 65 20 66 61 69 6c 65 64 27 0a 70 6f 73  gure failed'.pos
1760: 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69  tconfigure || di
1770: 65 20 27 70 6f 73 74 63 6f 6e 66 69 67 75 72 65  e 'postconfigure
1780: 20 66 61 69 6c 65 64 27 0a 0a 70 72 65 62 75 69   failed'..prebui
1790: 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65 62 75  ld || die 'prebu
17a0: 69 6c 64 20 66 61 69 6c 65 64 27 0a 62 75 69 6c  ild failed'.buil
17b0: 64 20 7c 7c 20 64 69 65 20 27 62 75 69 6c 64 20  d || die 'build 
17c0: 66 61 69 6c 65 64 27 0a 70 6f 73 74 62 75 69 6c  failed'.postbuil
17d0: 64 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 62 75  d || die 'postbu
17e0: 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ild failed'..pre
17f0: 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27  install || die '
1800: 70 72 65 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65  preinstall faile
1810: 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  d'.install || di
1820: 65 20 27 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65  e 'install faile
1830: 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c 6c 20 7c  d'.postinstall |
1840: 7c 20 64 69 65 20 27 70 6f 73 74 69 6e 73 74 61  | die 'postinsta
1850: 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28 0a 09 63  ll failed'..(..c
1860: 61 73 65 20 22 24 7b 74 61 72 67 65 74 6d 6f 64  ase "${targetmod
1870: 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74 61 6c 6c  e}" in...install
1880: 29 0a 09 09 09 61 70 70 64 69 72 3d 22 24 28 61  )....appdir="$(a
1890: 70 70 66 73 69 6e 73 74 61 6c 6c 64 69 72 29 2f  ppfsinstalldir)/
18a0: 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22  ${prefixsuffix}"
18b0: 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20 22 24 7b  ....mkdir -p "${
18c0: 61 70 70 64 69 72 7d 22 0a 0a 09 09 09 63 64 20  appdir}".....cd 
18d0: 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b 70 72  "${destdir}/${pr
18e0: 65 66 69 78 7d 22 20 7c 7c 20 65 78 69 74 20 31  efix}" || exit 1
18f0: 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a 20 22 24  .....cp -rp * "$
1900: 7b 61 70 70 64 69 72 7d 22 0a 09 09 09 66 69 6e  {appdir}"....fin
1910: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1920: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1930: 20 74 6f 75 63 68 20 2d 74 20 22 24 7b 70 6b 67   touch -t "${pkg
1940: 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22  date}"....find "
1950: 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e  ${appdir}" -prin
1960: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
1970: 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b 67  uch -m -t "${pkg
1980: 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22  date}"....find "
1990: 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e  ${appdir}" -prin
19a0: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
19b0: 75 63 68 20 2d 61 20 2d 74 20 22 24 7b 70 6b 67  uch -a -t "${pkg
19c0: 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a 09 09 61  date}"....;;...a
19d0: 72 63 68 69 76 65 29 0a 09 09 09 61 72 63 68 69  rchive)....archi
19e0: 76 65 66 69 6c 65 3d 22 24 7b 73 63 72 69 70 74  vefile="${script
19f0: 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65  dir}/${pkg}-${ve
1a00: 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f 20 22 24  rsion}-$(echo "$
1a10: 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20 73 65 64  {pkgdate}" | sed
1a20: 20 27 73 40 5c 2e 40 40 67 27 29 2d 24 7b 6f 73   's@\.@@g')-${os
1a30: 7d 2d 24 7b 61 72 63 68 7d 2d 24 7b 64 6f 6d 61  }-${arch}-${doma
1a40: 69 6e 7d 2e 63 70 69 6f 22 0a 09 09 09 63 64 20  in}.cpio"....cd 
1a50: 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b 70 72  "${destdir}/${pr
1a60: 65 66 69 78 7d 2f 2e 2e 2f 2e 2e 2f 2e 2e 22 20  efix}/../../.." 
1a70: 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 66 69 6e  || exit 1....fin
1a80: 64 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69  d "${prefixsuffi
1a90: 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61  x}" -print0 | xa
1aa0: 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20  rgs -0 touch -t 
1ab0: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
1ac0: 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75  find "${prefixsu
1ad0: 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c  ffix}" -print0 |
1ae0: 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20   xargs -0 touch 
1af0: 2d 6d 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  -m -t "${pkgdate
1b00: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72  }"....find "${pr
1b10: 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72  efixsuffix}" -pr
1b20: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
1b30: 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b 70  touch -a -t "${p
1b40: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
1b50: 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78   "${prefixsuffix
1b60: 7d 22 20 7c 20 73 6f 72 74 20 7c 20 63 70 69 6f  }" | sort | cpio
1b70: 20 2d 2d 6f 77 6e 65 72 20 30 3a 30 20 2d 48 20   --owner 0:0 -H 
1b80: 6e 65 77 63 20 2d 6f 20 3e 20 22 24 7b 61 72 63  newc -o > "${arc
1b90: 68 69 76 65 66 69 6c 65 7d 22 0a 09 09 09 3b 3b  hivefile}"....;;
1ba0: 0a 09 65 73 61 63 0a 29 20 7c 7c 20 64 69 65 20  ..esac.) || die 
1bb0: 27 66 69 6e 61 6c 20 69 6e 73 74 61 6c 6c 61 74  'final installat
1bc0: 69 6f 6e 20 66 61 69 6c 65 64 27 0a 0a 63 6c 65  ion failed'..cle
1bd0: 61 6e 75 70 0a 0a 65 78 69 74 20 30 0a           anup..exit 0.